Search Results for

Show / Hide Table of Contents

# Class MenuBar

The MenuBar provides a menu for Terminal.Gui applications.

##### Inheritance

System.Object
Responder
View
MenuBar

##### Implements

System.IDisposable
System.ComponentModel.ISupportInitializeNotification
System.ComponentModel.ISupportInitialize

##### Inherited Members

View.Added
View.Removed
View.Enter
View.Leave
View.MouseEnter
View.MouseLeave
View.MouseClick
View.HotKey
View.HotKeySpecifier
View.Shortcut
View.ShortcutTag
View.ShortcutAction
View.Data
View.Driver
View.Subviews
View.TabIndexes
View.TabIndex
View.TabStop
View.CanFocus
View.Id
View.IsCurrentTop
View.WantMousePositionReports
View.WantContinuousButtonPressed
View.Frame
View.LayoutStyle
View.Bounds
View.X
View.Y
View.Width
View.Height
View.SuperView
View.SetNeedsDisplay()
View.ClearLayoutNeeded()
View.SetNeedsDisplay(Rect)
View.SetChildNeedsDisplay()
View.Add(View)
View.Add(View[])
View.RemoveAll()
View.Remove(View)
View.BringSubviewToFront(View)
View.SendSubviewToBack(View)
View.SendSubviewBackwards(View)
View.BringSubviewForward(View)
View.Clear()
View.Clear(Rect)
View.ScreenToView(Int32, Int32)
View.ClipToBounds()
View.SetClip(Rect)
View.DrawFrame(Rect, Int32, Boolean)
View.DrawHotString(ustring, Attribute, Attribute)
View.DrawHotString(ustring, Boolean, ColorScheme)
View.Move(Int32, Int32)
View.HasFocus
View.OnAdded(View)
View.OnRemoved(View)
View.Focused
View.MostFocused
View.ColorScheme
View.AddRune(Int32, Int32, Rune)
View.ClearNeedsDisplay()
View.DrawContent
View.OnDrawContent(Rect)
View.SetFocus()
View.KeyPress
View.KeyDown
View.KeyUp
View.EnsureFocus()
View.FocusFirst()
View.FocusLast()
View.FocusPrev()
View.FocusNext()
View.LayoutStarted
View.LayoutComplete
View.Initialized
View.LayoutSubviews()
View.Text
View.AutoSize
View.TextAlignment
View.VerticalTextAlignment
View.TextDirection
View.IsInitialized
View.ToString()
View.OnMouseEnter(MouseEvent)
View.OnMouseLeave(MouseEvent)
View.OnMouseEvent(MouseEvent)
View.OnMouseClick(View.MouseEventArgs)
View.Dispose(Boolean)
View.BeginInit()
View.EndInit()
View.Visible
View.SetWidth(Int32, Int32)
View.SetHeight(Int32, Int32)
View.GetCurrentWidth(Int32)
View.GetCurrentHeight(Int32)
Responder.Dispose()
System.Object.Equals(System.Object)
System.Object.Equals(System.Object, System.Object)
System.Object.GetHashCode()
System.Object.GetType()
System.Object.MemberwiseClone()
System.Object.ReferenceEquals(System.Object, System.Object)

###### Namespace: Terminal.Gui

###### Assembly: Terminal.Gui.dll

##### Syntax

    public class MenuBar : View, IDisposable, ISupportInitializeNotification, ISupportInitialize

##### Remarks

The MenuBar appears on the first row of the terminal.

The MenuBar provides global hotkeys for the application.

### Constructors

#### MenuBar()

Initializes a new instance of the MenuBar.

##### Declaration

    public MenuBar()

#### MenuBar(MenuBarItem[])

Initializes a new instance of the MenuBar class with the specified set of toplevel menu items.

##### Declaration

    public MenuBar(MenuBarItem[] menus)

##### Parameters

Type | Name | Description
--- | --- | ---
MenuBarItem[] | menus | Individual menu items; a null item will result in a separator being drawn.

### Properties

#### IsMenuOpen

True if the menu is open; otherwise false.

##### Declaration

    public bool IsMenuOpen { get; protected set; }

##### Property Value

Type | Description
--- | ---
System.Boolean |

#### LastFocused

Get the lasted focused view before open the menu.

##### Declaration

    public View LastFocused { get; }

##### Property Value

Type | Description
--- | ---
View |

#### Menus

Gets or sets the array of MenuBarItems for the menu. Only set this when the MenuBar is vislble.

##### Declaration

    public MenuBarItem[] Menus { get; set; }

##### Property Value

Type | Description
--- | ---
MenuBarItem[] | The menu array.

#### ShortcutDelimiter

Used for change the shortcut delimiter separator.

##### Declaration

    public static ustring ShortcutDelimiter { get; set; }

##### Property Value

Type | Description
--- | ---
NStack.ustring |

#### UseKeysUpDownAsKeysLeftRight

Used for change the navigation key style.

##### Declaration

    public bool UseKeysUpDownAsKeysLeftRight { get; set; }

##### Property Value

Type | Description
--- | ---
System.Boolean |

### Methods

#### CloseMenu()

Closes the current Menu programatically, if open.

##### Declaration

    public void CloseMenu()

#### MouseEvent(MouseEvent)

##### Declaration

    public override bool MouseEvent(MouseEvent me)

##### Parameters

Type | Name | Description
--- | --- | ---
MouseEvent | me |

##### Returns

Type | Description
--- | ---
System.Boolean |

##### Overrides

Responder.MouseEvent(MouseEvent)

#### OnEnter(View)

##### Declaration

    public override bool OnEnter(View view)

##### Parameters

Type | Name | Description
--- | --- | ---
View | view |

##### Returns

Type | Description
--- | ---
System.Boolean |

##### Overrides

View.OnEnter(View)

#### OnKeyDown(KeyEvent)

##### Declaration

    public override bool OnKeyDown(KeyEvent keyEvent)

##### Parameters

Type | Name | Description
--- | --- | ---
KeyEvent | keyEvent |

##### Returns

Type | Description
--- | ---
System.Boolean |

##### Overrides

View.OnKeyDown(KeyEvent)

#### OnKeyUp(KeyEvent)

##### Declaration

    public override bool OnKeyUp(KeyEvent keyEvent)

##### Parameters

Type | Name | Description
--- | --- | ---
KeyEvent | keyEvent |

##### Returns

Type | Description
--- | ---
System.Boolean |

##### Overrides

View.OnKeyUp(KeyEvent)

#### OnLeave(View)

##### Declaration

    public override bool OnLeave(View view)

##### Parameters

Type | Name | Description
--- | --- | ---
View | view |

##### Returns

Type | Description
--- | ---
System.Boolean |

##### Overrides

View.OnLeave(View)

#### OnMenuClosing()

Virtual method that will invoke the MenuClosing

##### Declaration

    public virtual void OnMenuClosing()

#### OnMenuOpening()

Virtual method that will invoke the MenuOpening

##### Declaration

    public virtual void OnMenuOpening()

#### OpenMenu()

Opens the current Menu programatically.

##### Declaration

    public void OpenMenu()

#### PositionCursor()

##### Declaration

    public override void PositionCursor()

##### Overrides

View.PositionCursor()

#### ProcessColdKey(KeyEvent)

##### Declaration

    public override bool ProcessColdKey(KeyEvent kb)

##### Parameters

Type | Name | Description
--- | --- | ---
KeyEvent | kb |

##### Returns

Type | Description
--- | ---
System.Boolean |

##### Overrides

View.ProcessColdKey(KeyEvent)

#### ProcessHotKey(KeyEvent)

##### Declaration

    public override bool ProcessHotKey(KeyEvent kb)

##### Parameters

Type | Name | Description
--- | --- | ---
KeyEvent | kb |

##### Returns

Type | Description
--- | ---
System.Boolean |

##### Overrides

View.ProcessHotKey(KeyEvent)

#### ProcessKey(KeyEvent)

##### Declaration

    public override bool ProcessKey(KeyEvent kb)

##### Parameters

Type | Name | Description
--- | --- | ---
KeyEvent | kb |

##### Returns

Type | Description
--- | ---
System.Boolean |

##### Overrides

View.ProcessKey(KeyEvent)

#### Redraw(Rect)

##### Declaration

    public override void Redraw(Rect bounds)

##### Parameters

Type | Name | Description
--- | --- | ---
Rect | bounds |

##### Overrides

View.Redraw(Rect)

### Events

#### MenuClosing

Raised when a menu is closing.

##### Declaration

    public event Action MenuClosing

##### Event Type

Type | Description
--- | ---
System.Action |

#### MenuOpening

Raised as a menu is opening.

##### Declaration

    public event Action MenuOpening

##### Event Type

Type | Description
--- | ---
System.Action |

### Implements

System.IDisposable
System.ComponentModel.ISupportInitializeNotification
System.ComponentModel.ISupportInitialize